package q2_Pkg;

import java.awt.Container;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * This class encapsulates a JFrame child that is very simple; it contains a
 * single JPanel component of type Q1CustomizedPanel. The preferred size for
 * this window is determined by the preferred size of its component.
 * 
 * @author mb
 * 
 */
public class Q2Frame extends JFrame {

	/**
	 */
	public Q2Frame() {
		/*
		 * We do not set the preferred size of the root container; rather, let
		 * the preferred size of each of the child components determine the size
		 * of this container
		 */

		this.setTitle("Question2 Frame");

		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setResizable(true);

		Container rootContainer = this.getContentPane();
		/**
		 * We use the BoxLayout as the layout manager; this allows us to add as
		 * many components as we would like to the root container (via the "add"
		 * method); the layout manager will put all of the child components in
		 * row, one after another.
		 */
		this.setLayout(new BoxLayout(rootContainer, BoxLayout.LINE_AXIS));

		JPanel panel1 = new Q2CustomizedPanel();
		rootContainer.add(panel1);

		/*
		 * the method pack() causes this JFrame to be sized to fit the preferred
		 * size and layouts of its subcomponents.
		 */
		this.pack();
		this.setVisible(true);
	}

}
