package soln.q1_Pkg;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;

/**
 * This class encapsulates a JFrame child that is very simple; it contains a
 * single JPanel component of type Q1CustomizedPanel. The preferred size for
 * this window is determined by the preferred size of its component.
 * 
 * @author mb
 * 
 */
public class Q1Frame extends JFrame {

	/**
	 */
	public Q1Frame() {
		/*
		 * We do not set the preferred size of the root container; rather, let
		 * the preferred size of each of the child components determine the size
		 * of this container
		 */

		this.setTitle("Question1 Frame");

		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setResizable(true);

		Container rootContainer = this.getContentPane();
		/**
		 * We use the BoxLayout as the layout manager; this allows us to add as
		 * many components as we would like to the root container (via the "add"
		 * method); the layout manager will put all of the child components in
		 * row, one after another.
		 */
		this.setLayout(new BoxLayout(rootContainer, BoxLayout.LINE_AXIS));

		JPanel panel1 = new Q1CustomizedPanel();
		JPanel panel2 = new Q1CustomizedPanel();
		JPanel panel3 = new Q1CustomizedPanel();
		rootContainer.add(panel1);
		rootContainer.add(panel2);
		rootContainer.add(panel3);

		/*
		 * the method pack() causes this JFrame to be sized to fit the preferred
		 * size and layouts of its subcomponents.
		 */
		this.pack();
		this.setVisible(true);
	}

}
