package soln.q2_Pkg;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.Stroke;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JPanel;

/**
 * This class encapsulates a JPanel that has different appearances, depending on
 * whether the width of the JPanel is smaller than the height or not.
 * 
 * <br />
 * If the width of this JPanel is greater than its height, then the background
 * color is GRAY. The shape drawn on this JPanel is the outline of an ellipse.
 * The ellipse is centered and has width and height that is equal to this
 * JPanel's width and height, respectively. The outline color of the ellipse is
 * YELLOW.
 * 
 * <br />
 * If the width of this JPanel is smaller than or equal to its height, then the
 * background color is DARK_GRAY. The shape drawn on this JPanel is the outline
 * of a rectangle. The rectangle is centered and has width and height that is
 * equal to this JPanel's width and height, respectively. The outline color of
 * the rectangle is ORANGE.
 * 
 * <br />
 * The stroke of the outline of the shapes is 3 points.
 * 
 * <br />
 * This component specifies a preferred initial size of 400x200.
 * 
 */
public class Q2CustomizedPanel extends JPanel {

	private static final long serialVersionUID = 1L; // we define this in order
														// to satisfy the
														// compiler

	/**
	 * Constructor
	 */
	public Q2CustomizedPanel() {
		/*
		 * the line below would be invoked by default even it we hadn't
		 * specified it. This corresponds to the constructor JPanel() [see API]
		 */
		super();
		int width = 400;
		int height = 200;
		this.setPreferredSize(new Dimension(width, height));

	}

	/**
	 * This method implements how this component should be drawn.
	 * 
	 * This method is called when the windowing system determines that the
	 * window to which this component belongs should be re-rendered. The
	 * paint(Graphics g) method is invoked on each of the window's components.
	 * Each of those invocations, in turn, invokes this method,
	 * paintComponent(Graphics g).
	 * 
	 * Swing programs should override paintComponent() instead of overriding
	 * paint() [ref: http://java.sun.com/products/jfc/tsc/articles/painting/]
	 * 
	 */
	@Override
	public void paintComponent(Graphics g) {
		super.paintComponent(g);

		Graphics2D g2 = (Graphics2D) g;

		int width = this.getWidth();
		int height = this.getHeight();

		g2.setPaint(Color.GRAY);
		g2.fill(new Rectangle2D.Double(0, 0, width, height));
		g2.setPaint(Color.MAGENTA);
		final int PT_SIZE = 24;
		g2.setFont(new Font("Sans", Font.ITALIC, PT_SIZE));
		g2.drawString("WELCOME TO QUESTION1", 0, height / 2);

	}
}
