package soln.q2_Pkg;

import java.awt.Component;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

/**
 * This class encapsulates a listener for mouse motion events.
 * 
 * <br/>
 * If the mouse is moving, then this listener prints to the console which
 * quadrant of the screen the user is moving in. For instance, if the user is
 * moving in the top right quadrant, the string that should be printed to the
 * console is "UPPER-RIGHT" (the strings for the other quadrants are
 * "UPPER-LEFT", "LOWER-RIGHT", "LOWER_LEFT").
 * 
 * <br/>
 * If the mouse motion event corresponds to the user dragging the mouse, this
 * listener should do nothing.
 * 
 * @author mb
 * 
 */
public class Q2MouseMotionListener implements MouseMotionListener {

	@Override
	public void mouseDragged(MouseEvent e) {
		// System.out.println(e);
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		// System.out.println(e);

		/**
		 * Hint #1: examine the API of MouseEvent and look for a method that
		 * "Returns the x,y position of the event relative to the source component."
		 */

		/**
		 * Hint #2: the following statements may be of use:
		 * 
		 * Component component = (Component) e.getSource();
		 * 
		 * int width = component.getWidth();
		 * 
		 * int height = component.getHeight();
		 */

		Component component = (Component) e.getSource();
		int width = component.getWidth();
		int height = component.getHeight();

		String str = "";
		Point p = e.getPoint();

		if (p.y < height / 2) {
			str = "UPPER-";
		} else {
			str = "LOWER-";
		}

		if (p.x < width / 2) {
			str = str + "LEFT";
		} else {
			str = str + "RIGHT";
		}
		
		System.out.println(str);
	}
}
